//+------------------------------------------------------------------+
/////////////CYCLE TRIANGULAR CENTERED END-POINT  
//////////////Sohocool March 2012

//|                                       
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
 
 
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LawnGreen
#property indicator_color2  Red
#property indicator_color3  Blue
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  1



extern string TimeFrame       = "Current time frame";
extern int    Fast_HalfLength = 24;    
extern int    Slow_HalfLength = 48;
extern int    PRICE           = 5; 

//---- indicator buffers
double ind_buffer3a[];
double ind_buffer3b[];
double ind_buffer4[];
double slope[];

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,ind_buffer3a);SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ind_buffer3b);SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ind_buffer4);
   SetIndexBuffer(3,slope);
   
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
   IndicatorShortName(timeFrameToString(timeFrame)+" Cycle Tma End-Point  ("+Fast_HalfLength+","+Slow_HalfLength+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Average of Oscillator                                     |
//+------------------------------------------------------------------+
int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ind_buffer3a[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
      
   if (calculateValue || timeFrame==Period())
   {
     for(i=limit; i>=0; i--) ind_buffer4[i]=iMA(NULL,0,Fast_HalfLength,0,3,PRICE,i) -iMA(NULL,0,Slow_HalfLength,0,3,PRICE,i);
     for(i=limit; i>=0; i--) 
     {
        ind_buffer3a[i]=EMPTY_VALUE;
        ind_buffer3b[i]=EMPTY_VALUE;      
        slope[i] = slope[i+1];
           if (ind_buffer4[i]>ind_buffer4[i+1]) slope[i] = 1;
           if (ind_buffer4[i]<ind_buffer4[i+1]) slope[i] =-1;
           if (slope[i] == 1) ind_buffer3a[i]=ind_buffer4[i];
           if (slope[i] ==-1) ind_buffer3b[i]=ind_buffer4[i];
     } 
     return(0);
   }

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--) 
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         ind_buffer4[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Fast_HalfLength,Slow_HalfLength,PRICE,2,y);
         slope[i]       = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Fast_HalfLength,Slow_HalfLength,PRICE,3,y);
         ind_buffer3a[i]=EMPTY_VALUE;
         ind_buffer3b[i]=EMPTY_VALUE;
         if (slope[i] == 1) ind_buffer3a[i]=ind_buffer4[i];
         if (slope[i] ==-1) ind_buffer3b[i]=ind_buffer4[i];  
   }
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
return(s);
}
